/*
Better?
*/

freeslot(
"MT_TAILSSWEAT",
"SPR_SWET",
"S_TAILS_SWEAT1",
"S_TAILS_SWEAT2",
"S_PLAY_VDED2",
"SPR_SHET",
"S_PLAY_ZZZZ",
"SPR_EEPY",
"sfx_slep",
"sfx_wosh",
"sfx_rzoom",
"sfx_tsr2",
"sfx_ouch"
)

sfxinfo[sfx_wosh] = {
	singular = false,
	caption = "Boosting Flight"
}

sfxinfo[sfx_drill2] = {
	singular = false,
	caption = "Upward"
}
sfxinfo[sfx_spdpad] = {
	singular = false,
	caption = "Momentum Dash"
}

sfxinfo[sfx_zoom] = {
	singular = false,
	caption = "Thokking"
}

sfxinfo[sfx_slep] = {
	singular = false,
	caption = "Tap"
}

sfxinfo[sfx_rzoom] = {
	singular = false,
	caption = "Awakened"
}

states[S_PLAY_VDED2] = {
        sprite = SPR_SHET,
        frame = A,
        tics = 230,
		nextstate = S_PLAY_VDED2
}

states[S_PLAY_ZZZZ] = {
        sprite = SPR_EEPY,
        frame = A,
        tics = 230,
		nextstate = S_PLAY_ZZZZ
}

COM_AddCommand("babymode", function(player, arg1)
    if arg1 == "1" then
	    CONS_Printf(player, ":child:")
		S_StartSound(player.mo, sfx_cdpcm4)
        player.babymode = 1
		child = child * 0 -- "tried to do arithmetic on child, a nil value"
    elseif arg1 == "0" then
	    CONS_Printf(player, ":nomorechild:.")
		S_StartSound(player.mo, sfx_zoom)
        player.babymode = 0
    end
end)

addHook("PostThinkFrame", function(player)
	for player in players.iterate
		if player.mo.skin == "azure" then
			player.mo.frame = $|FF_SEMIBRIGHT
			if player.followmobj
				player.followmobj.frame = $|FF_SEMIBRIGHT
			end
		end
	end
end)

addHook("MobjThinker", function(tails)
	if tails and tails.skin == "azure"
		if ((tails.state == S_PLAY_FLY) or (tails.state == S_PLAY_FLY_TIRED) or (tails.state == S_PLAY_SWIM))
			if tails.player.powers[pw_tailsfly] == 44
			or tails.player.powers[pw_tailsfly] == 22
			or tails.player.powers[pw_tailsfly] == 1
				P_SpawnMobj(tails.x, tails.y, tails.z + 51*FRACUNIT, MT_TAILSSWEAT)
				S_StartSound(tails, sfx_s3k42)
			end
		end	
	end
end, MT_PLAYER)

addHook("PlayerThink", function(player)
	if player.mo.skin == "azure"
	and player.pflags & PF_SPINNING
		player.charflags = $1|SF_CANBUSTWALLS
	end
	if player.mo.skin == "azure"
	and not (player.pflags & PF_SPINNING)
		player.charflags = $ & ~SF_CANBUSTWALLS
	end
end)

-- SA1 Tails flight by TeriosSonic
-- Free to use as long as you credit me.
-- Remember to add the SF_MULTIABILITY flag to your char and set his actionspd to 125 [normal SA1 Tails flight]
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and player.mo.skin == "azure"
		if player.powers[pw_tailsfly] > 5*TICRATE
			player.powers[pw_tailsfly] = 5*TICRATE
		end
		if player.bot == 1
			player.charflags = $ & ~SF_MULTIABILITY
		else
			player.charflags = $ |SF_MULTIABILITY
		end
		if player.powers[pw_super]
			player.actionspd = 200*FRACUNIT
			if player.powers[pw_tailsfly] > 7
				player.powers[pw_tailsfly] = 8*TICRATE
			end
		else
			player.actionspd = 150*FRACUNIT
		end
	end
end)

// he sleepo
COM_AddCommand("sleepmode", function(player, arg1)
	if player.mo.skin ~= "azure" return end
    if arg1 == "on" then
		S_StartSound(player.mo, sfx_slep)
		player.sleep = true
	elseif arg1 == "off" then
		player.sleep = false
		S_StartSound(player.mo, sfx_rzoom)
		player.mo.state = S_PLAY_EDGE
    end
end)

/*COM_AddCommand("drippy", function(player, arg1)
	if player.mo.skin ~= "azure" return end
    if arg1 == "on" then
		S_StartSound(player.mo, sfx_floush)
		player.drippy = true
	elseif arg1 == "off" then
		player.drippy = false
		S_StartSound(player.mo, sfx_zoom)
		player.mo.state = S_PLAY_EDGE
    end
end)*/

addHook("PostThinkFrame", function(player)
	for player in players.iterate
		if player.mo.skin ~= "azure" return end
		if player.sleep == nil
			player.sleep = false
		end
		if player.drippy == nil
			player.drippy = false
		end
		if player.sleeping == nil
			player.sleeping = 0
		end
		if player.sleep == true
			player.sleeping = 1
		end
		if player.sleep == false
			player.sleeping = 0
		end
		if player.sleeping == 1
			player.pflags = $|PF_GODMODE|PF_FULLSTASIS
			player.powers[pw_carry] = 0
			player.mo.state = S_PLAY_ZZZZ
		end
		if player.sleeping == 0
			player.pflags = $ & ~(PF_GODMODE|PF_FULLSTASIS)
		end
	end
end)

//tailswipe
addHook("PlayerThink", function(player)
	if not (player.spinning)
		player.spinning = 0
	end
	if (player.mo.skin == "azure")
	and not (player.cmd.buttons & BT_CUSTOM2)
		player.thrustfactor = 4
	end
	if player.mo and (player.mo.skin == "azure")
	and (player.cmd.buttons & BT_CUSTOM2)
	and (P_IsObjectOnGround(player.mo))
	and not (player.playerstate == PST_DEAD)
		player.thrustfactor = 3
		S_StartSound(player.mo, sfx_cdfm70)
		P_SpawnSkidDust(player, 10*FRACUNIT, sfx_none)
		player.mo.state = S_PLAY_EDGE
		local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = player.mo.color
		ghost.colorized = true
		ghost.fuse = 3
		if (player.pflags & PF_SPINNING)
			player.pflags = $ & ~(PF_SPINNING)
		end
		player.spinning = ($ % 8) + 1
		if (player.spinning > 8)
			player.spinning = 0
		end
		player.drawangle = player.spinning * ANGLE_45
	end
end)
addHook("PlayerThink", function(player)
	if not (player.spinning)
		player.spinning = 0
	end
	if (player.mo.skin == "azure")
	and not (player.cmd.buttons & BT_CUSTOM2)
	end
	if player.mo and (player.mo.skin == "azure")
	and (player.cmd.buttons & BT_CUSTOM2)
	and not (P_IsObjectOnGround(player.mo))
	and not (player.playerstate == PST_DEAD)
		P_SetObjectMomZ(player.mo, 2*FRACUNIT/9, true)
		player.mo.state = S_PLAY_EDGE
		local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = player.mo.color
		ghost.colorized = true
		ghost.fuse = 3
		//player.speenmusic = $1 + 1
		if (player.pflags & PF_SPINNING)
			player.pflags = $ & ~(PF_SPINNING)
		end
		player.spinning = ($ % 8) + 1
		if (player.spinning > 8)
			player.spinning = 0
		end
		player.drawangle = player.spinning * ANGLE_45
	end
end)

local function Beyblade(enemy, mobj)
	local player = mobj.player
	if (player.mo.skin ~= "azure")
	end
	if (player.mo.skin ~= "azure") and (player.cmd.buttons & BT_CUSTOM2)
		if (enemy.flags & (MF_ENEMY|MF_BOSS))
			P_DamageMobj(enemy, mobj, mobj)
		end
	end
end
addHook("TouchSpecial", Beyblade)

addHook("PlayerCanDamage", function(player, mobj)
	if player.mo.skin == "azure"
	and not (player.cmd.buttons & BT_CUSTOM2)
	and not (player.playerstate == PST_DEAD)
	end
    if player.mo.valid and player.mo.skin == "azure"
    and (player.cmd.buttons & BT_CUSTOM2)
        return true
    end
end)

//thok fix 
//addHook("PlayerThink", function(player)
addHook("ThinkFrame", do
	for player in players.iterate
		if player.recurled == nil
			player.recurled = 0
		end
		if player.recurled == 1
		and P_IsObjectOnGround(player.mo)
			player.recurled = 0
		end
		if player.recurled >= 1
		and not P_IsObjectOnGround(player.mo)
			player.recurled = 1
		end
	end
end)


//downward thok
addHook("PlayerThink", function(player)
	if player.mo.skin == "azure"
	and (player.cmd.buttons & BT_SPIN)
	and not (P_IsObjectOnGround(player.mo))
	and not (player.pflags & PF_THOKKED)
	and not (player.playerstate == PST_DEAD)
	and not (player.mo.sprite2 == SPR2_TRNS)
	and player.recurled ~= 1
	    player.pflags = $1 & ~PF_JUMPED
		P_SetObjectMomZ(player.mo, -7*FRACUNIT, true)
		P_Thrust(player.mo, player.mo.angle, 9*FRACUNIT/2)
		player.mo.state = S_PLAY_ROLL
		S_StartSound(player.mo, sfx_zoom)
		local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
		thok.color = player.mo.color
		player.pflags = $1|PF_THOKKED|PF_SPINNING
		player.pflags = $ & ~(PF_NOJUMPDAMAGE)
		S_StartSound(player.mo, sfx_s3k42)
		P_SpawnThokMobj(player)
		player.recurled = 1
	end
end)

//upward thok
addHook("PlayerThink", function(player)
	if player.mo.skin == "azure" and (player.cmd.buttons & BT_CUSTOM1)
	and not (player.pflags & PF_THOKKED)
	and not (player.cmd.buttons & BT_CUSTOM2)
	and not	(P_IsObjectOnGround(player.mo))
	and not (player.playerstate == PST_DEAD)
	and player.recurled ~= 1
		local a = P_SpawnMobj(player.mo.x - 6*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
		local b = P_SpawnMobj(player.mo.x + 6*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
		local c = P_SpawnMobj(player.mo.x, player.mo.y - 6*FRACUNIT, player.mo.z, MT_SPINDUST)
		local d = P_SpawnMobj(player.mo.x, player.mo.y + 6*FRACUNIT, player.mo.z, MT_SPINDUST)
		local e = P_SpawnMobj(player.mo.x - 6*FRACUNIT, player.mo.y - 6*FRACUNIT, player.mo.z, MT_SPINDUST)
		local f = P_SpawnMobj(player.mo.x + 6*FRACUNIT, player.mo.y - 6*FRACUNIT, player.mo.z, MT_SPINDUST)
		local g = P_SpawnMobj(player.mo.x - 6*FRACUNIT, player.mo.y + 6*FRACUNIT, player.mo.z, MT_SPINDUST)
		local h = P_SpawnMobj(player.mo.x + 6*FRACUNIT, player.mo.y + 6*FRACUNIT, player.mo.z, MT_SPINDUST)
		P_InstaThrust(a, player.mo.angle, player.speed)
		P_InstaThrust(b, player.mo.angle, player.speed)
		P_InstaThrust(c, player.mo.angle, player.speed)
		P_InstaThrust(d, player.mo.angle, player.speed)
		P_InstaThrust(e, player.mo.angle, player.speed)
		P_InstaThrust(f, player.mo.angle, player.speed)
		P_InstaThrust(g, player.mo.angle, player.speed)
		P_InstaThrust(h, player.mo.angle, player.speed)
		P_SetObjectMomZ(player.mo, 24*FRACUNIT/5, true)
		P_Thrust(player.mo, player.mo.angle, 11*FRACUNIT/3, true)
		S_StartSound(player.mo, sfx_zoom)
		S_StartSound(player.mo, sfx_drill2)
		P_SpawnThokMobj(player)
		player.mo.state = S_PLAY_ROLL
		player.pflags = $ |(PF_JUMPED|PF_THOKKED)
		player.pflags = $ & ~(PF_NOJUMPDAMAGE)
		player.recurled = 1
    end
end)

//roll effect owo
addHook("PostThinkFrame", function(player)
	for player in players.iterate
		if player.mo.skin ~= "azure" return end
		if player.mo.state == S_PLAY_ROLL
		local ghost = P_SpawnGhostMobj(player.mo)
			ghost.fuse = 7
			ghost.color = player.mo.color
			ghost.blendmode = AST_TRANSLUCENT
			ghost.frame = player.mo.frame
			ghost.destscale = 1*FRACUNIT/10
			ghost.tracer.fuse = 7
			ghost.tracer.color = player.mo.color
			ghost.tracer.blendmode = AST_TRANSLUCENT
			ghost.tracer.frame = player.mo.frame
			ghost.tracer.destscale = 1*FRACUNIT/10
		end
	end
end)

//oh my fuckking god
addHook("PlayerThink", function(player)
	if player and player.valid and player.mo.skin == "azure" 
	and (player.powers[pw_super])
	and (player.speed >= 1*FRACUNIT)
	and not (player.speed >= 6*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 1*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 6*FRACUNIT)
	and not (player.speed >= 11*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 2*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 11*FRACUNIT)
	and not (player.speed >= 16*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 3*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 16*FRACUNIT)
	and not (player.speed >= 21*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 4*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 21*FRACUNIT)
	and not (player.speed >= 26*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 5*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 26*FRACUNIT)
	and not (player.speed >= 31*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 6*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 31*FRACUNIT)
	and not (player.speed >= 36*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 7*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 36*FRACUNIT)
	and not (player.speed >= 41*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 8*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 41*FRACUNIT)
	and not (player.speed >= 46*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 9*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 46*FRACUNIT)
	and not (player.speed >= 51*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 10*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 51*FRACUNIT)
	and not (player.speed >= 56*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 11*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 56*FRACUNIT)
	and not (player.speed >= 61*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 12*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 61*FRACUNIT)
	and not (player.speed >= 66*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 13*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 66*FRACUNIT)
	and not (player.speed >= 71*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 14*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 71*FRACUNIT)
	and not (player.speed >= 76*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 15*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 76*FRACUNIT)
	and not (player.speed >= 81*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 16*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 81*FRACUNIT)
	and not (player.speed >= 88*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 17*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 88*FRACUNIT)
	and not (player.speed >= 96*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 18*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 96*FRACUNIT)
	and not (player.speed >= 101*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 19*FRACUNIT/10
		ghost.fuse = 8
	end
	if player and player.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and (player.speed >= 101*FRACUNIT)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.fuse = 8
		ghost.color = player.mo.color
		ghost.blendmode = AST_ADD
		ghost.frame = player.mo.frame
		ghost.fuse = 20
		ghost.destscale = 20*FRACUNIT/10
		ghost.fuse = 8
	end
end)
//killll
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and (player.trans)
		player.trans = $ + 1
	end
	if (player.mo.valid) and (player.mo.skin == "azure")
		if (player.mo.sprite2 == SPR2_TRNS)
			for p in players.iterate
				P_SetupLevelSky(59)
				if not p.trans
					p.trans = 1
				end
			end
		end
	end
	if player.mo and player.mo.valid and player.mo.skin == "azure"
	and (player.powers[pw_super])
	and not player.sleeping == 1
		player.pflags = $ & ~(PF_GODMODE)
	else
		if player.mo and player.mo.valid and (player.mo.skin == "azure")
		and (player.powers[pw_super])
		player.pflags = $1 | PF_GODMODE
		A_GoldMonitorSparkle(player.mo, 0, 0)
		local enemy = P_LookForEnemies(player)
			if not (enemy) return end
			if (enemy.valid)
			and (enemy.flags & MF_ENEMY)
			or (enemy.flags & MF_BOSS)
				P_KillMobj(enemy)
			local explosion = P_SpawnMobj(enemy.x, enemy.y, enemy.z, MT_CYBRAKDEMON_FLAMEREST)
				explosion.scale = enemy.scale
				explosion.target = player.mo
			end
			//player.pflags = $1 | PF_GODMODE
		end
	end
end)

//this is basically just tsr code lmfao
//EDIT: 12*FRACUNIT --> 14*FRACUNIT
//EDIT: Removed
//EDIT: added back
addHook("ThinkFrame", do
  for p in players.iterate
    if not p.mo or not p.mo.valid continue end
    if p.mo.skin == "azure" and p.powers[pw_tailsfly] and p.cmd.buttons & BT_CUSTOM1
	and not (p.mo.playerstate == PST_DEAD)
	  p.powers[pw_tailsfly] = 0
	  p.mo.state = S_PLAY_SPRING
	  P_SetObjectMomZ(p.mo, 12*FRACUNIT, true)
	  P_SpawnGhostMobj(p.mo)
	  S_StartSound(p.mo, sfx_spdpad)
	  P_InstaThrust(p.mo, p.mo.angle, p.speed)
    end
  end
end)

addHook("MapLoad", function()
	if gamemap == 16
		P_SetupLevelSky(35)
		P_SwitchWeather(PRECIP_STORM)
	end
end)

addHook("MobjCollide", function(thing, tmthing)
  if (tmthing.skin ~= "azure" or not tmthing.player) then return end
  if thing.z + thing.height < tmthing.z + tmthing.momz or thing.z > tmthing.z + tmthing.momz + tmthing.height then return nil end
  local p = tmthing.player
  if p.valid and p.powers[pw_super] or (p.cmd.buttons & BT_CUSTOM2) then
    P_KillMobj(thing, tmthing, tmthing, nil, nil)
  end
end, MT_SPIKE)
//NEW: He gets a intial burst of height when he starts flying, for removing upwards thok
addHook("AbilitySpecial", function(player)
	if player.mo.skin == "azure"
	and (player.pflags & PF_JUMPED)
	and not (player.pflags & PF_THOKKED)
	and not (player.mo.state == S_PLAY_FLY)
	and not (player.playerstate == PST_DEAD)
		P_SetObjectMomZ(player.mo, 7*FRACUNIT/3, true)
		S_StartSound(player.mo, sfx_wosh)
		for i = 1,18
		local wind = P_SPMAngle(player.mo,MT_SPINDUST,player.mo.angle+(ANG20*i),1)
			P_SetObjectMomZ(wind, 0, false)
			P_InstaThrust(wind,wind.angle,10*FRACUNIT)
		end
	end
end)
/*addHook("PlayerThink", function(player)
	if player.speenmusic == nil
	and (player.mo.skin == "azure")
		player.speenmusic = 0
	end
	if (player.speenmusic >= 0)
	and (player.mo.skin == "azure")
	and not (player.cmd.buttons & BT_CUSTOM2)
	   player.speenmusic = $1 - 1
	end
	if (player.speenmusic == 420)
	and (player.mo.skin == "azure")
		player.speenmusic = 420
		P_PlayJingleMusic(player, "SPINME",JT_OTHER)
	end
	if (player.speenmusic > 420)
	and (player.mo.skin == "azure")
		local ghost3 = P_SpawnGhostMobj(player.mo)
		ghost3.color = player.mo.color
		ghost3.blendmode = AST_ADD
		ghost3.colorized = true
		ghost3.fuse = 8
	end
	if (player.speenmusic > 69)
	and (player.mo.skin == "azure")
	and not(player.cmd.buttons & BT_CUSTOM2)
		player.speenmusic = 69
		P_RestoreMusic(player)
	end
end)*/
//freeslot("sfx_tsr2", "sfx_ouch")
//dust effects from TSR's Lua
addHook("PlayerThink", function(player)
	if (player.mo and player.mo.skin == "azure")
	and player.playerstate == PST_LIVE
	and not player.powers[pw_super]
	and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and not (player.playerstate == PST_DEAD)
		if (player.panim == PA_RUN or player.panim == PA_DASH)
		and P_IsObjectOnGround(player.mo)
			if player.speed >= player.runspeed
			local runparticle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + ((player.mo.eflags & MFE_VERTICALFLIP)/MFE_VERTICALFLIP * (player.mo.height - mobjinfo[MT_DUST].height)), MT_DUST)
				if player.mo.eflags & MFE_VERTICALFLIP
				runparticle.eflags = $1|MFE_VERTICALFLIP
				runparticle.flags2 = $1|MF2_OBJECTFLIP
				end
			P_InstaThrust(runparticle, player.mo.angle+(P_RandomRange(-ANG10/FRACUNIT, ANG10/FRACUNIT)*FRACUNIT), FixedMul(-player.runspeed/12-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
			P_InstaThrust(runparticle, player.mo.angle+(P_RandomRange(-ANG10/FRACUNIT, ANG10/FRACUNIT)*FRACUNIT), FixedMul(-player.runspeed/13-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
			P_InstaThrust(runparticle, player.mo.angle+(P_RandomRange(-ANG20/FRACUNIT, ANG20/FRACUNIT)*FRACUNIT), FixedMul(-player.runspeed/15-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
			P_InstaThrust(runparticle, player.mo.angle+(P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT), FixedMul(-player.runspeed/15-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
			P_TryMove(runparticle, runparticle.x+runparticle.momx, runparticle.y+runparticle.momy, true)
			P_SetObjectMomZ(runparticle, 2*FRACUNIT, true)
				if (player.mo.eflags & (MFE_UNDERWATER))
				runparticle.state = S_SPINDUST_BUBBLE1
				elseif (player.powers[pw_shield] == SH_ELEMENTAL)
				runparticle.state = S_SPINDUST_FIRE1
				end
			end
		end
	end
end)
//dust for his flight
//reused lua functions cause im lazy af
addHook("PlayerThink", function(player)
	if (player.mo and player.mo.skin == "azure")
	and player.playerstate == PST_LIVE
	and not player.powers[pw_super]
	and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and not (player.playerstate == PST_DEAD)
		if player.mo.state == S_PLAY_FLY
		local runparticle = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-30, 30) * FRACUNIT, P_RandomRange(-30, 30) * FRACUNIT, P_RandomRange(-30, 30)*FRACUNIT, MT_DUST)
			if player.mo.eflags & MFE_VERTICALFLIP
			runparticle.eflags = $1|MFE_VERTICALFLIP
			runparticle.flags2 = $1|MF2_OBJECTFLIP
			end
		P_InstaThrust(runparticle, player.mo.angle+(P_RandomRange(-ANG10/FRACUNIT, ANG10/FRACUNIT)*FRACUNIT), FixedMul(-player.runspeed/12-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
		P_InstaThrust(runparticle, player.mo.angle+(P_RandomRange(-ANG10/FRACUNIT, ANG10/FRACUNIT)*FRACUNIT), FixedMul(-player.runspeed/7-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
		P_TryMove(runparticle, runparticle.x+runparticle.momx, runparticle.y+runparticle.momy, true)
		P_SetObjectMomZ(runparticle, -11*FRACUNIT, true)
			if (player.mo.eflags & (MFE_UNDERWATER))
			runparticle.state = S_SPINDUST_BUBBLE1
			end
		end
	end
end)

//some reused code
addHook("PostThinkFrame", function(player)
	for player in players.iterate
		if (player.mo.valid) and player.mo.skin ~= "azure" return end
		if (player.mo.valid) and player.powers[pw_carry] & CR_ROLLOUT return end
		if (player.mo.valid) //and player.mo.fenspeed == true --idk if i want this
		and not (player.playerstate == PST_DEAD)
		and not (P_IsObjectOnGround(player.mo))
			if player.mo.state == S_PLAY_WALK
			or player.mo.state == S_PLAY_STND
				player.mo.state = S_PLAY_FALL
			end
		end
	end
end)

//azure's death animation - Scripted by PRBlaster
//edit: removed till fixed in multiplayer
//edit: added back (another script was causing a bug)
addHook("PlayerThink", function(player)
	if not (player.mo.valid) and (player.mo.skin == "azure") return end
	if player.playdsound == nil
		player.playdsound = 0
	end
	if player.playdsound == 1
	and not player.playdsound == 0
		player.playdsound = 0
		S_StartSound(player.mo, sfx_ouch)
		P_StartQuake(200*FRACUNIT, 6)
	end
	if player.playerstate == PST_DEAD
	and player.mo.skin == "azure"
	and not (player.mo.subsector.sector.floorpic == "F_SKY1" or not player.mo.subsector.sector.floorpic == "PIT")
		P_InstaThrust(player.mo, player.mo.angle, player.speed/2)
		player.mo.flags = $ & ~MF_NOCLIP
		player.mo.flags = $ & ~MF_NOCLIPHEIGHT
		player.mo.frame = $|FF_VERTICALFLIP
	end
	if (P_IsObjectOnGround(player.mo))
	and player.mo.skin == "azure"
	and player.playerstate == PST_DEAD
	and not (player.mo.subsector.sector.floorpic == "F_SKY1" or not player.mo.subsector.sector.floorpic == "PIT") then
		player.mo.momz = 0
		player.mo.momx = 0
		player.mo.momy = 0
		player.mo.state = S_PLAY_VDED2
		player.playdsound = 1
	end
end)

addHook("MobjMoveBlocked", function(mo)
    local player = mo.player
	if player.mo.skin == "azure"
    and player.mo.state == S_PLAY_DEAD
	and player.playerstate == PST_DEAD
	player.mo.momz = player.speed/4
	S_StartSound(player.mo, sfx_cybdth)
	player.mo.state = S_PLAY_PAIN
	P_InstaThrust(player.mo, player.mo.angle, -player.speed/2)
	end
end, MT_PLAYER)

//ghost effect for speedo
addHook("PostThinkFrame", function(player)
	for player in players.iterate
		if (player.mo.skin == "azure")
		and player.playerstate == PST_LIVE
			if player.speed >= 66*FRACUNIT
			and player.playerstate == PST_LIVE
			//and not P_IsObjectOnGround(player.mo)
				//player.panim = PA_RUN
				//player.mo.state = S_PLAY_RUN
				//player.mo.momz = abs($)>FRACUNIT and $*4/5 or 0
				if player.speed >= 88*FRACUNIT
					//P_Thrust(player.mo,player.mo.angle,FRACUNIT/21)
				local ghost = P_SpawnGhostMobj(player.mo)
					ghost.color = player.mo.color
					ghost.colorized = true
					ghost.fuse = 3
					ghost.blendmode = AST_ADD
					ghost.destscale = 12*FRACUNIT/10
					ghost.tracer.color = player.mo.color
					ghost.tracer.colorized = true
					ghost.tracer.fuse = 3
					ghost.tracer.blendmode = AST_ADD
					ghost.tracer.destscale = 12*FRACUNIT/10
				else
					//P_Thrust(player.mo,player.mo.angle,FRACUNIT/9)
				end
			local ghost = P_SpawnGhostMobj(player.mo)
				ghost.color = player.mo.color
				ghost.colorized = true
				ghost.fuse = 2
				ghost.blendmode = AST_TRANSLUCENT
				ghost.destscale = 6*FRACUNIT/10
				ghost.tracer.color = player.mo.color
				ghost.tracer.colorized = true
				ghost.tracer.fuse = 2
				ghost.tracer.blendmode = AST_TRANSLUCENT
				ghost.tracer.destscale = 6*FRACUNIT/10
				//funni
				//player.mo.flags = $ | MF_BOUNCE
			end
		end
	end
end)

//HELL YEAH
//Classic spindash behavior by rumia1!
addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.valid
		and not (player.mo.state == S_PLAY_DEAD)
			if(player.mo.skin == "azure")
			//setting up the variable to check for how many charges the current spindash has
				if player.spincharges == nil
					player.spincharges = 0
				end
			//this one checks how long the spindash has been held for
				if player.dashtime == nil
				or not (player.pflags & PF_STARTDASH)
					player.dashtime = 15
				end
			//and this one checks how many automatic charges we've added, as we can only have 4
				if player.dashcounter == nil
				or not (player.pflags & PF_STARTDASH)
					player.dashcounter = 0
				end
			//checks if player was holding jump last frame
				if player.jumpwasdown == nil
					player.jumpwasdown = 0
				end
				
				if player.forwardwasdown == nil
					player.forwardwasdown = 0
				end
				if player.backwasdown == nil
					player.backwasdown = 0
				end
				if player.leftwasdown == nil
					player.leftwasdown = 0
				end
				if player.rightwasdown == nil
					player.rightwasdown = 0
				end
				
			//makes our life easier
 				if player.pflags & PF_STARTDASH
 					player.dashspeed = player.maxdash
 					player.mindash = player.maxdash - (21*player.dashspeed)
 				end
		
				if player.dashcounter >= 3
					player.dashcounter = 3
				end
				if player.dashtime <= 0
					player.dashtime = 15
				end
				if testing == true then print(player.dashcounter, player.dashtime, player.dashspeed/FRACUNIT, player.spincharges) end
				if (player.pflags & PF_STARTDASH)
					player.jumpfactor = 0
					player.dashtime = $ - 1
					if player.spincharges == 0
						player.mindash = 23*FRACUNIT
						player.maxdash = 25*FRACUNIT
						player.mindash = player.maxdash - (21*player.dashspeed)
					else
						player.maxdash = (25*FRACUNIT) + (player.spincharges*(5*FRACUNIT))
					end
					if (player.cmd.forwardmove >= 25)
					and not (player.forwardwasdown)
					or (player.cmd.forwardmove <= -25)
					and not (player.backwasdown)
					or (player.cmd.sidemove >= 25)
					and not (player.rightwasdown)
					or (player.cmd.sidemove <= -25)
					and not (player.leftwasdown)
					or (player.cmd.buttons & BT_JUMP)
					and not (player.jumpwasdown)
						if player.spincharges < 15
							player.spincharges = $ + 1
						else
							player.spincharges = 15
						end
						S_StopSound(player.mo)
						S_StartSound(player.mo, 478 + player.spincharges)
					end

				else
					player.jumpfactor = skins[player.mo.skin].jumpfactor
					player.spincharges = 0
				end
			//Our "was jump pressed last frame?" check ends here
				player.jumpwasdown = (player.cmd.buttons & BT_JUMP)
				if (player.cmd.forwardmove >= 25)
					player.forwardwasdown = 1
				else
					player.forwardwasdown = 0
				end
				if (player.cmd.forwardmove <= -25)
					player.backwasdown = 1
				else
					player.backwasdown = 0
				end
				if (player.cmd.sidemove >= 25)
					player.rightwasdown = 1
				else
					player.rightwasdown = 0
				end
				if (player.cmd.sidemove <= -25)
					player.leftwasdown = 1
				else
					player.leftwasdown = 0
				end
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player and player.valid and player.mo.skin == "azure" and player.cmd.forwardmove then
		if (player.speed > player.normalspeed) and player.mo.skin == "azure" and player.cmd.forwardmove
		and not (player.speed >= 99*FRACUNIT)
			player.mo.friction = FRACUNIT + (FRACUNIT/2023)
		end
	end
end)
addHook("PlayerThink", function(player)
	if (player.pflags == PF_SLIDING) return end
	if player and player.valid and player.mo.skin == "azure" and player.cmd.sidemove then
		if (player.speed > player.normalspeed) and player.mo.skin == "azure" and player.cmd.sidemove
		and not (player.speed >= 99*FRACUNIT)
			player.mo.friction = FRACUNIT + (FRACUNIT/2023)
		end
	end
end)

addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "azure")
		local women = P_LookForEnemies(player)
		if not (women) return end
		if (women.valid)
		and women.type == MT_ROSY
			P_KillMobj(women)
			local explosion = P_SpawnMobj(women.x, women.y, women.z, MT_EXPLODE)
			explosion.scale = women.scale*20
			explosion.target = player.mo
			S_StartSound(nil, sfx_cdpcm5)
			COM_BufInsertText(player, "csay no more women!!!!")
		end
	end
end)

/*addHook("PlayerThink", function(p)
	if p.speed >= 28*FRACUNIT
	and p.mo.state == S_PLAY_RUN
	or p.mo.state == S_PLAY_JUMP
	or p.mo.state == S_PLAY_FLY
	or p.mo.state == S_PLAY_SWIM
		if p.mo.skin == "azure"
			local pitch = min(p.speed, 30*FRACUNIT)
			local angle = p.drawangle - camera.angle
			print(angle)
			p.mo.rollangle = FixedAngle(FixedMul(sin(angle), pitch))
		end
	end
end)*/
